//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

#include <tigcclib.h>

//-----------------------------------------------------------------------------

int FastExp(int a, int e, int n);

//-----------------------------------------------------------------------------

int FastExp(int a, int e, int n)
{
	int r=1;
	
	a=div(a,n).rem;
	e&=0x7FFF; // (INT) SIZE -> 16 BITS
	
	while (e)
	{
		if (e&1)
		r=div(r*a,n).rem;
		
		a=div(a*a,n).rem;
		
		e>>=1;
	}
	
	return r;
}

//-----------------------------------------------------------------------------

// Main Function
void _main(void)
{
	
	int a;
	int e;
	int n;
	
	
	char buffer[50];
	
	clrscr();
	FontSetSys(0);
	printf("FastExp 1.0 \n");
	printf("Programmed by Olivier Sangala \n");
	printf("http://olivier.sangala.free.fr \n");
	printf("olivier_sangala@hotmail.com \n");
	FontSetSys(1);
	ngetchx();
	
	lbl_start:
	
	clrscr();
	printf("a=");gets(buffer);a=atoi(buffer);printf("\n");
	printf("e=");gets(buffer);e=atoi(buffer);printf("\n");
	printf("n=");gets(buffer);n=atoi(buffer);printf("\n");
	
	if (n==0)
	{
		printf("Error : n=0 \n");
		ngetchx();
		goto lbl_start;
	}
	
	a=div(a,n).rem;
	e&=0x7FFF; // (INT) SIZE -> 16 BITS
	
	printf("\n");
	printf("%d^%d mod %d = %d \n\n",a,e,n,FastExp(a,e,n));
	
	printf("[ENTER] : Continue \n");
	printf("[ESC] : Exit");
	
	int key;
	while ((key=ngetchx())!=KEY_ENTER && key!=KEY_ESC);
	
	if (key==KEY_ENTER)
	goto lbl_start;
	
}
